Attribute VB_Name = "Mod1"
Option Explicit

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Function ByteToHex(bHex() As Byte) As String
    Dim lLen As Long
    Dim lPntr As Long
    Dim HexStr As String
    lLen = GetbSize(bHex())
    If lLen > 0 Then
        HexStr = String$(lLen * 2, Chr$(0))
        For lPntr = 0 To UBound(bHex)
            Mid$(HexStr, (lPntr * 2 + 1), 2) = Right$("0" & Hex$(bHex(lPntr)), 2)
        Next lPntr
        ByteToHex = HexStr
    End If
End Function

Public Sub DebugPrintByte(sDescr As String, bArray() As Byte)
    Dim lPtr As Long
    Debug.Print sDescr & ":"
    For lPtr = 0 To UBound(bArray)
        Debug.Print Right$("0" & Hex$(bArray(lPtr)), 2) & " ";
        If (lPtr + 1) Mod 16 = 0 Then Debug.Print
    Next lPtr
    Debug.Print
End Sub

Public Sub DebugPrintUni(sDescr As String, strToPrint As String)
    Dim lPtr As Long
    Dim sSep As String * 1
    Debug.Print sDescr & ":"
    For lPtr = 0 To Len(strToPrint) * 2 - 1
        Debug.Print Right$("0" & Hex$(PeekB(StrPtr(strToPrint) + lPtr)), 2) & " ";
        If (lPtr + 2) Mod 16 = 0 Then Debug.Print
    Next lPtr
    Debug.Print
End Sub

Public Function PeekB(ByVal lpdwData As Long) As Byte
    CopyMemory PeekB, ByVal lpdwData, 1
End Function

Public Function GetbSize(bArray() As Byte) As Long
    On Error GoTo GetSizeErr
    GetbSize = UBound(bArray) + 1
    Exit Function
GetSizeErr:
    GetbSize = 0
End Function


Public Function HexToByte(HexStr As String, bHex() As Byte) As Boolean
    Dim lLen As Long
    Dim lPntr As Long
    If Len(HexStr) > 1 Then
        lLen = Len(HexStr) / 2
        ReDim bHex(lLen - 1)
        For lPntr = 0 To UBound(bHex)
            bHex(lPntr) = Val("&H" & Mid$(HexStr, lPntr * 2 + 1, 2))
        Next lPntr
        HexToByte = True
    End If
End Function

Public Function ByteToUni(bArray() As Byte) As String
    ByteToUni = bArray
End Function

Public Function UniToByte(strInput As String) As Byte()
    UniToByte = strInput
End Function


