VERSION 5.00
Begin VB.Form frmMaint 
   Caption         =   "Password Maintenance"
   ClientHeight    =   4965
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9525
   LinkTopic       =   "Form1"
   ScaleHeight     =   4965
   ScaleWidth      =   9525
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDelete 
      Caption         =   "DeleteCurrent Record"
      Height          =   495
      Left            =   3120
      TabIndex        =   8
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save Edited Record"
      Height          =   495
      Left            =   4680
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
   Begin VB.ListBox lstPW 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3660
      Left            =   1320
      TabIndex        =   6
      Top             =   1200
      Width           =   8055
   End
   Begin VB.ListBox lstUser 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3660
      Left            =   120
      TabIndex        =   5
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add to file"
      Height          =   495
      Left            =   6240
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtPW 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   1440
      TabIndex        =   1
      Top             =   840
      Width           =   7815
   End
   Begin VB.TextBox txtUser 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   840
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Password (Hex)"
      Height          =   255
      Left            =   1440
      TabIndex        =   3
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "UserID"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1215
   End
End
Attribute VB_Name = "frmMaint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim LogFile%
Dim CurrentIndex As Long
Private Function FileErrors(errVal As Integer) As Integer
'Return Value 0=Resume,              1=Resume Next,
'             2=Unrecoverable Error, 3=Unrecognized Error
Dim msgType%
Dim Msg$
Dim Response%
msgType% = 48
Select Case errVal
    Case 68
      Msg$ = "That device appears Unavailable."
      msgType% = msgType% + 4
    Case 71
      Msg$ = "Insert a Disk in the Drive"
    Case 53
      Msg$ = "Cannot Find File"
      msgType% = msgType% + 5
   Case 57
      Msg$ = "Internal Disk Error."
      msgType% = msgType% + 4
    Case 61
      Msg$ = "Disk is Full.  Continue?"
      msgType% = 35
    Case 64, 52
      Msg$ = "That Filename is Illegal!"
    Case 70
      Msg$ = "File in use by another user!"
      msgType% = msgType% + 5
    Case 76
      Msg$ = "Path does not Exist!"
      msgType% = msgType% + 2
    Case 54
      Msg$ = "Bad File Mode!"
    Case 55
      Msg$ = "File is Already Open."
    Case 62
      Msg$ = "Read Attempt Past End of File."
    Case Else
      FileErrors = 3
      Exit Function
  End Select
  Response% = MsgBox(Msg$, msgType%, "Disk Error")
  Select Case Response%
    Case 1, 4
      FileErrors = 0
    Case 5
      FileErrors = 1
    Case 2, 3
      FileErrors = 2
    Case Else
      FileErrors = 3
  End Select
End Function

Private Function OpenFile(FileName$, Mode%, RLock%, RecordLen%) As Integer
  Const REPLACEFILE = 1, READAFILE = 2, ADDTOFILE = 3
  Const RANDOMFILE = 4, BINARYFILE = 5
  Const NOLOCK = 0, RDLOCK = 1, WRLOCK = 2, RWLOCK = 3
  Dim FileNum%
  Dim Action%
  FileNum% = FreeFile
  On Error GoTo OpenErrors
  Select Case Mode
    Case REPLACEFILE
        Select Case RLock%
            Case NOLOCK
                Open FileName For Output Shared As FileNum%
            Case RDLOCK
                Open FileName For Output Lock Read As FileNum%
            Case WRLOCK
                Open FileName For Output Lock Write As FileNum%
            Case RWLOCK
                Open FileName For Output Lock Read Write As FileNum%
        End Select
    Case READAFILE
        Select Case RLock%
            Case NOLOCK
                Open FileName For Input Shared As FileNum%
            Case RDLOCK
                Open FileName For Input Lock Read As FileNum%
            Case WRLOCK
                Open FileName For Input Lock Write As FileNum%
            Case RWLOCK
                Open FileName For Input Lock Read Write As FileNum%
        End Select
    Case ADDTOFILE
        Select Case RLock%
            Case NOLOCK
                Open FileName For Append Shared As FileNum%
            Case RDLOCK
                Open FileName For Append Lock Read As FileNum%
            Case WRLOCK
                Open FileName For Append Lock Write As FileNum%
            Case RWLOCK
                Open FileName For Append Lock Read Write As FileNum%
        End Select
    Case RANDOMFILE
        Select Case RLock%
            Case NOLOCK
                Open FileName For Random Shared As FileNum% Len = RecordLen%
            Case RDLOCK
                Open FileName For Random Lock Read As FileNum% Len = RecordLen%
            Case WRLOCK
                Open FileName For Random Lock Write As FileNum% Len = RecordLen%
            Case RWLOCK
                Open FileName For Random Lock Read Write As FileNum% Len = RecordLen%
        End Select
    Case BINARYFILE
        Select Case RLock%
            Case NOLOCK
                Open FileName For Binary Shared As FileNum%
            Case RDLOCK
                Open FileName For Binary Lock Read As FileNum%
            Case WRLOCK
                Open FileName For Binary Lock Write As FileNum%
            Case RWLOCK
                Open FileName For Binary Lock Read Write As FileNum%
        End Select
    Case Else
      Exit Function
  End Select
  OpenFile = FileNum%
Exit Function
OpenErrors:
  Action% = FileErrors(Err)
  Select Case Action%
    Case 0
      Resume            'Resumes at line where ERROR occured
    Case 1
        Resume Next     'Resumes at line after ERROR
    Case 2
        OpenFile = 0     'Unrecoverable ERROR-reports error, exits function with error code
        Exit Function
    Case Else
        MsgBox Error$(Err) + vbCrLf + "After line " + CStr(Erl) + vbCrLf + "Program will TERMINATE!"
        'Unrecognized ERROR-reports error and terminates.
        'End
  End Select
End Function

Private Sub UpdateDB()
    Dim FileName As String
    Dim BackName As String
    Dim lPntr As Long
    Dim bUserRecord(51) As Byte
    Dim bUser() As Byte
    Dim bPW() As Byte
    Dim sUser As String
    Dim sPW As String
    FileName = "\ProgramData\EChat\users.db"
    BackName = "\ProgramData\EChat\users.bak"
    FileCopy FileName, BackName
    Kill FileName
    LogFile% = OpenFile(FileName, 4, 3, 52)
    For lPntr = 0 To lstUser.ListCount - 1
        sUser = Left$(lstUser.List(lPntr) & String$(10, Chr$(0)), 10)
        bUser = UniToByte(sUser)
        Call HexToByte(lstPW.List(lPntr), bPW)
        CopyMemory bUserRecord(0), bUser(0), GetbSize(bUser)
        CopyMemory bUserRecord(20), bPW(0), GetbSize(bPW)
        Put #LogFile%, , bUserRecord
    Next lPntr
    Close #LogFile%
End Sub

Private Sub UpdateList()
    Dim FileName As String
    Dim bUserRecord(51) As Byte
    Dim bUser(19) As Byte
    Dim bPW(31) As Byte
    Dim sUser As String
    Dim sPW As String
    lstUser.Clear
    lstPW.Clear
    FileName = "\ProgramData\EChat\users.db"
    LogFile% = OpenFile(FileName, 4, 3, 52)
    Do Until EOF(LogFile%)
        Get #LogFile%, , bUserRecord
        If bUserRecord(0) > 0 Then
            CopyMemory bUser(0), bUserRecord(0), GetbSize(bUser)
            sUser = ByteToUni(bUser)
            lstUser.AddItem sUser
            CopyMemory bPW(0), bUserRecord(20), GetbSize(bPW)
            sPW = ByteToHex(bPW)
            lstPW.AddItem sPW
        End If
    Loop
    Close #LogFile%
End Sub


Private Sub cmdAdd_Click()
    Dim bUserRecord(51) As Byte
    Dim bUser() As Byte
    Dim bPW() As Byte
    If Len(txtUser.Text) < 3 Or Len(txtUser.Text) > 10 Then
        MsgBox "User name must be greater than 3 and less then 11!", vbExclamation
        Exit Sub
    End If
    If Len(txtPW.Text) <> 64 Then
        MsgBox "Password requires 64 octal characters!" & vbCrLf _
            & "All zeros will be substituted!", vbExclamation
        txtPW.Text = String$(64, "0")
    End If
    lstUser.AddItem txtUser.Text
    lstPW.AddItem txtPW.Text
    txtUser.Text = ""
    txtPW.Text = ""
End Sub

Private Sub cmdDelete_Click()
    Dim iRow As Integer
    iRow = CurrentIndex - 1
    lstUser.RemoveItem iRow
    lstPW.RemoveItem iRow
    txtUser.Text = ""
    txtPW.Text = ""
End Sub

Private Sub cmdSave_Click()
    Dim bUserRecord(51) As Byte
    Dim bUser() As Byte
    Dim bPW() As Byte
    If Len(txtUser.Text) < 3 Or Len(txtUser.Text) > 10 Then
        MsgBox "User name must be greater than 2 and less then 11!", vbExclamation
        Exit Sub
    End If
    If Len(txtPW.Text) <> 64 Then
        MsgBox "Password requires 64 octal characters!", vbExclamation
        Exit Sub
    End If
    CurrentIndex = lstUser.ListIndex
    lstUser.RemoveItem CurrentIndex
    lstPW.RemoveItem CurrentIndex
    lstUser.AddItem txtUser.Text, CurrentIndex
    lstPW.AddItem txtPW.Text, CurrentIndex
    txtUser.Text = ""
    txtPW.Text = ""
End Sub


Private Sub Form_Load()
    Call UpdateList
End Sub



Private Sub Form_Unload(Cancel As Integer)
    Call UpdateDB
End Sub


Private Sub lstPW_Click()
    txtPW.Text = lstPW.Text
    lstUser.ListIndex = lstPW.ListIndex
    txtUser.Text = lstUser.Text
    CurrentIndex = lstPW.ListIndex + 1
End Sub

Private Sub lstUser_Click()
    txtUser.Text = lstUser.Text
    lstPW.ListIndex = lstUser.ListIndex
    txtPW.Text = lstPW.Text
    CurrentIndex = lstUser.ListIndex + 1
End Sub


