Attribute VB_Name = "basGeneral"
Option Explicit

Public Declare Function Encrypt Lib "jCrypt.dll" (bText() As Byte, bKey() As Byte) As Byte()
Public Declare Function GetECCKey Lib "jCrypt.dll" (ByVal pAlg As Long, ByVal KeyLen As Long, bPubKey() As Byte, bPriKey() As Byte) As Byte()
Public Declare Function GenRandom Lib "jCrypt.dll" (ByVal cbBuffer As Long) As Byte()
Public Declare Function HashData Lib "jCrypt.dll" (ByVal lAlg As Long, bText() As Byte) As Byte()
Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Public PWHash() As Byte

Public Function ByteToHex(bHex() As Byte) As String
    Dim lLen As Long
    Dim lPntr As Long
    Dim HexStr As String
    lLen = GetbSize(bHex())
    If lLen > 0 Then
        HexStr = String$(lLen * 2, Chr$(0))
        For lPntr = 0 To UBound(bHex)
            Mid$(HexStr, (lPntr * 2 + 1), 2) = Right$("0" & Hex$(bHex(lPntr)), 2)
        Next lPntr
        ByteToHex = HexStr
    End If
End Function

Public Sub DebugPrintByte(sDescr As String, bArray() As Byte)
    Dim lPtr As Long
    Debug.Print sDescr & ":"
    For lPtr = 0 To UBound(bArray)
        Debug.Print Right$("0" & Hex$(bArray(lPtr)), 2) & " ";
        If (lPtr + 1) Mod 16 = 0 Then Debug.Print
    Next lPtr
    Debug.Print
End Sub

Public Sub DebugPrintString(sDescr As String, strToPrint As String)
    Dim lPtr As Long
    Dim sSep As String * 1
    Debug.Print sDescr & ":"
    For lPtr = 0 To Len(strToPrint) * 2 - 1 Step 2
        If PeekB(StrPtr(strToPrint) + lPtr + 1) > 0 Then
            sSep = "*"
        Else
            sSep = " "
        End If
        Debug.Print Right$("0" & Hex$(PeekB(StrPtr(strToPrint) + lPtr)), 2) & sSep;
        If (lPtr + 2) Mod 32 = 0 Then Debug.Print
    Next lPtr
    Debug.Print
End Sub

Public Function GetRndKey(lRandom As Long) As Byte()
    GetRndKey = GenRandom(32)
End Function


