VERSION 5.00
Object = "{E7BC34A0-BA86-11CF-84B1-CBC2DA68BF6C}#1.0#0"; "NTSVC.ocx"
Begin VB.Form frmHidden 
   Caption         =   "EChat"
   ClientHeight    =   3225
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   1845
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3225
   ScaleWidth      =   1845
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.ListBox lstUser 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3180
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   1815
   End
   Begin VB.TextBox txtHidden 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   1215
   End
   Begin NTService.NTService Service1 
      Left            =   1440
      Top             =   0
      _Version        =   65536
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   0
      DisplayName     =   "DNS Filter Svc"
      ServiceName     =   "DNSFilSvc"
      StartMode       =   3
   End
End
Attribute VB_Name = "frmHidden"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Implements SimpleServer
Private mServer() As New SimpleServer
Private Max_Connect As Long

Const gsDelimiter As String = "|"
Const VerMaj As Byte = 1
Const VerMin As Byte = 0

Private WinDir As String
Private IsService As Boolean
Private StopService As Boolean
Public gAppName As String
Public FormFail As Boolean
Dim IPVersion As Long
Private RemotePort As Long
Private RemoteHostIP As String
Private lIndex As Long

Dim bEncryptKey() As Byte
Dim RandomKey() As Byte

Dim bPubKeyInt() As Byte
Dim bPrivKeyInt() As Byte
Dim bPubKeyBlob() As Byte
Dim bHeader() As Byte

Dim DisconnectMsg As String

Public PortListen As Long
Public NewKeyName As String
Dim LastConnect As String
Dim User() As String
Dim Users() As String

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Declare Sub GetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)


Function FileErrors(errVal As Long) As Integer
    Dim Msg$, msgType%, Response%
'Return Value 0=Resume,              1=Resume Next,
'             2=Unrecoverable Error, 3=Unrecognized Error
msgType% = 48
Select Case errVal
    Case 68
      Msg$ = "That device appears Unavailable."
      msgType% = msgType% + 4
    Case 71
      Msg$ = "Insert a Disk in the Drive"
    Case 53
      Msg$ = "Cannot Find File"
      msgType% = msgType% + 5
   Case 57
      Msg$ = "Internal Disk Error."
      msgType% = msgType% + 4
    Case 61
      Msg$ = "Disk is Full.  Continue?"
      msgType% = 35
    Case 64, 52
      Msg$ = "That Filename is Illegal!"
    Case 70
      Msg$ = "File in use by another user!"
      msgType% = msgType% + 5
    Case 76
      Msg$ = "Path does not Exist!"
      msgType% = msgType% + 2
    Case 54
      Msg$ = "Bad File Mode!"
    Case 55
      Msg$ = "File is Already Open."
    Case 62
      Msg$ = "Read Attempt Past End of File."
    Case Else
      FileErrors = 3
      Exit Function
  End Select
  FileErrors = 2
End Function

Private Function GetEncrKey(ByVal Index As Long, bBuffer() As Byte) As Byte()
    Dim sTmp As String
    Dim uTmp As String
    Dim lTmp As Long
    Dim Result As Long
    Dim vKeys As Variant
    Dim vExceptions As Variant
    Dim vData As Variant
    Dim flgSend As Boolean
    Dim sPublicKey As String
    Dim bPubKeyBlob() As Byte
    Dim sPubKeyInt As String
    Dim bPubKeyInt() As Byte
    Dim bPrivKeyInt() As Byte
    Dim SharedSecret As String
    Dim bSharedSecret() As Byte
    Dim bMsgKey() As Byte
    Dim bResponse() As Byte
    Dim bTmp() As Byte
    Dim M%
    'Extract Public Key blob
    ReDim bPubKeyBlob(71)
    CopyMemory bPubKeyBlob(8), bBuffer(0), 64
    'Adjust header
    CopyMemory bPubKeyBlob(0), bHeader(0), 8
    'Get Internal Public/Private Keys
    ReDim bPubKeyInt(0)
    ReDim bPrivKeyInt(0)
    bTmp = GetECCKey(StrPtr("ECDH_P256"), 256, bPubKeyInt, bPrivKeyInt)
    If bTmp(0) <> 0 Then
        ReDim bTmp(0)
        GetEncrKey = bTmp
        Exit Function
    Else
        Call DebugPrintByte("Server Public Key Blob", bPubKeyInt)
        bSharedSecret = GetECCKey(StrPtr("ECDH_P256"), 256, bPubKeyBlob, bPrivKeyInt)
        If GetbSize(bSharedSecret) = 0 Then
            Call SimpleServer_CloseSck(lIndex)
            Exit Function
        Else
            bEncryptKey = bSharedSecret
            Call DebugPrintByte("Shared Secret", bEncryptKey)
            Call DebugPrintByte("Server Response", bPubKeyInt)
            GetEncrKey = bPubKeyInt
        End If
    End If
End Function

Private Function GetNextSocket() As Long
    Dim lNum As Long
    For lNum = 0 To Max_Connect
        If mServer(lNum).State = 0 Then Exit For 'Closed socket found
    Next lNum
    GetNextSocket = lNum
End Function


Private Function GetSettings(sKey As String) As String
    GetSettings = GetSetting(gAppName, "Settings", sKey, "")
End Function

Private Function GetUser(bBuffer() As Byte) As String
    Dim sTmp As String
    Dim lTmp As Long
    'Extract UserID
    lTmp = GetbSize(bBuffer) - 64
    sTmp = String$(lTmp / 2, Chr$(0))
    CopyMemory ByVal StrPtr(sTmp), bBuffer(64), lTmp
    GetUser = sTmp
End Function

Private Sub GetUserFile()
    Dim LogFile%
    Dim FileName As String
    Dim bUserRecord(51) As Byte
    Dim bUser(19) As Byte
    Dim bPW(31) As Byte
    Dim sUser As String
    Dim sPW As String
    Dim lPntr As Long
    ReDim Users(1, 20)
    FileName = "\ProgramData\EChat\users.db"
    LogFile% = OpenFile(FileName, 4, 3, 52)
    Do Until EOF(LogFile%)
        Get #LogFile%, , bUserRecord
        If bUserRecord(0) > 0 Then
            CopyMemory bUser(0), bUserRecord(0), GetbSize(bUser)
            txtHidden.Text = ByteToUni(bUser)
            Users(0, lPntr) = txtHidden.Text
            CopyMemory bPW(0), bUserRecord(20), GetbSize(bPW)
            sPW = ByteToHex(bPW)
            Users(1, lPntr) = sPW
        End If
        lPntr = lPntr + 1
    Loop
    ReDim Preserve Users(1, lPntr - 2)
    Close #LogFile%
End Sub

Private Function IsValidUser(sUser As String) As Boolean
    Dim lPntr As Long
    For lPntr = 0 To UBound(Users, 2)
        If sUser = Users(0, lPntr) Then
            IsValidUser = True
            Exit Function
        End If
    Next lPntr
    IsValidUser = False
End Function


Private Function GetWindowsDir() As String
    Dim Temp$, x%
    Temp$ = String$(145, 0)              ' Size Buffer
    x% = GetWindowsDirectory(Temp$, 145)  ' Make API Call
    Temp$ = Left$(Temp$, x%)              ' Trim Buffer

    If Right$(Temp$, 1) <> "\" Then      ' Add \ if necessary
        GetWindowsDir$ = Temp$ + "\"
    Else
        GetWindowsDir$ = Temp$
    End If
End Function

Private Function IsValidPassword(sUser As String, PasswordHash() As Byte) As Boolean
    Dim lPntr As Long
    Dim sHex As String
    For lPntr = 0 To UBound(Users, 2)
        If sUser = Users(0, lPntr) Then 'User found
            sHex = ByteToHex(PasswordHash)
            If sHex = Users(1, lPntr) Then IsValidPassword = True
            Exit Function
        End If
    Next lPntr
    IsValidPassword = False
End Function


Private Sub AddRecHeader(RecType As Byte, Record() As Byte)
    Dim bTmp() As Byte
    Dim RecLen As Long
    RecLen = GetbSize(Record)
    ReDim bTmp(RecLen + 7)
    If RecLen > 0 Then
        CopyMemory bTmp(8), Record(0), RecLen
    End If
    bTmp(0) = RecType
    bTmp(1) = VerMaj
    bTmp(2) = VerMin
    bTmp(3) = 0 'Reserved
    bTmp(4) = 0 'Reserved
    bTmp(5) = 0 'Reserved
    bTmp(6) = Int(RecLen / 256)
    bTmp(7) = RecLen Mod 256
    Record = bTmp
End Sub

Private Sub AdjRecHeader(RecType As Byte, Record() As Byte)
    Dim RecLen As Long
    RecLen = GetbSize(Record) - 8
    Record(0) = RecType
    Record(1) = VerMaj
    Record(2) = VerMin
    Record(3) = 0 'Reserved
    Record(4) = 0 'Reserved
    Record(5) = 0 'Reserved
    Record(6) = Int(RecLen / 256)
    Record(7) = RecLen Mod 256
End Sub


Sub ChkInstall()
    Select Case UCase(Command)
        Case "-I", "/I"
            If Service1.Install Then
                Service1.SaveSetting "Parameters", "TimerInterval", "60"
                MsgBox Service1.DisplayName & " installed successfully."
            Else
                MsgBox Service1.DisplayName & " did not install successfully."
            End If
            End
        Case "-U", "/U"
            If Service1.Uninstall Then
                MsgBox Service1.DisplayName & " uninstalled successfully."
            Else
                MsgBox Service1.DisplayName & " did not uninstall successfully."
            End If
            End
        Case ""
            '-- Application is started without parameters
            ' enable Pause/Continue. Must be set before StartService
            ' is called or in design mode
            Service1.ControlsAccepted = svcCtrlPauseContinue
            ' connect service to Windows NT services controller
            Service1.StartService
       Case Else
            MsgBox "The parameter: " & Command & " was not understood. Try -I (install) or -U (uninstall)."
            End
    End Select
    Exit Sub
chkInstallErr:
    Call Service1.LogEvent(svcMessageError, svcEventError, "[" & Err.Number & "] " & Err.Description)
    End
End Sub

Sub LogAccess(Log$, Optional NoTime As Boolean)
    Dim LogFile%
    Dim FileName As String
    If IsService Then
        FileName = WinDir & "system32\logfiles\EChat\" & Format(Date$, "yymmdd") & ".log"
    Else
        FileName = App.Path & "\Logs\" & Format(Date$, "yymmdd") & ".log"
    End If
    On Error Resume Next 'If file does not exist default to overwrite
    If Fix(Now) > Fix(FileDateTime(FileName)) Then
        'Overwrite file
        LogFile% = OpenFile(FileName, 1, 0, 80)
    Else
        'Add to file
        LogFile% = OpenFile(FileName, 3, 0, 80)
    End If
    If LogFile% = 0 Then
        Exit Sub
    End If
    If NoTime Then
        Print #LogFile%, Log$
    Else
        Print #LogFile%, Log$ & gsDelimiter & Format(Now, "hh:mm:ss")
    End If
    Close LogFile%
    On Error GoTo 0
End Sub

Function OpenFile(FileName$, Mode%, RLock%, RecordLen%) As Integer
    Const REPLACEFILE = 1, READAFILE = 2, ADDTOFILE = 3
    Const RANDOMFILE = 4, BINARYFILE = 5
    Const NOLOCK = 0, RDLOCK = 1, WRLOCK = 2, RWLOCK = 3
    Dim ErrorCode As Long
    Dim FileNum%, Action%, LockFlg%
    LockFlg% = 0
    FileNum% = FreeFile
    On Error GoTo OpenErrors
    Select Case Mode
        Case REPLACEFILE
            Select Case RLock%
                Case NOLOCK
                    Open FileName For Output Shared As FileNum%
                Case RDLOCK
                    Open FileName For Output Lock Read As FileNum%
                Case WRLOCK
                    Open FileName For Output Lock Write As FileNum%
                Case RWLOCK
                    Open FileName For Output Lock Read Write As FileNum%
            End Select
        Case READAFILE
            Select Case RLock%
                Case NOLOCK
                    Open FileName For Input Shared As FileNum%
                Case RDLOCK
                    Open FileName For Input Lock Read As FileNum%
                Case WRLOCK
                    Open FileName For Input Lock Write As FileNum%
                Case RWLOCK
                    Open FileName For Input Lock Read Write As FileNum%
            End Select
        Case ADDTOFILE
            Select Case RLock%
                Case NOLOCK
                    Open FileName For Append Shared As FileNum%
                Case RDLOCK
                    Open FileName For Append Lock Read As FileNum%
                Case WRLOCK
                    Open FileName For Append Lock Write As FileNum%
                Case RWLOCK
                    Open FileName For Append Lock Read Write As FileNum%
            End Select
        Case RANDOMFILE
            Select Case RLock%
                Case NOLOCK
                    Open FileName For Random Shared As FileNum% Len = RecordLen%
                Case RDLOCK
                    Open FileName For Random Lock Read As FileNum% Len = RecordLen%
                Case WRLOCK
                    Open FileName For Random Lock Write As FileNum% Len = RecordLen%
                Case RWLOCK
                    Open FileName For Random Lock Read Write As FileNum% Len = RecordLen%
            End Select
        Case BINARYFILE
            Select Case RLock%
                Case NOLOCK
                    Open FileName For Binary Shared As FileNum%
                Case RDLOCK
                    Open FileName For Binary Lock Read As FileNum%
                Case WRLOCK
                    Open FileName For Binary Lock Write As FileNum%
                Case RWLOCK
                    Open FileName For Binary Lock Read Write As FileNum%
            End Select
        Case Else
          Exit Function
    End Select
    OpenFile = FileNum%
    Exit Function
OpenErrors:
    If Err = 70 Then  'File is locked, try 3 times
        LockFlg% = LockFlg% + 1
        Debug.Print "File Locked!"
        If LockFlg > 3 Then GoTo OpenErrCont
        Resume
    End If
OpenErrCont:
    ErrorCode = Err
    Action% = FileErrors(ErrorCode)
    Select Case Action%
        Case 0
          Resume            'Resumes at line where ERROR occured
        Case 1
            Resume Next     'Resumes at line after ERROR
        Case 2
            OpenFile = 0     'Unrecoverable ERROR-reports error, exits function with error code
            Exit Function
        Case Else
            'MsgBox Error$(Err) + vbCrLf + "After line " + Str$(Erl) + vbCrLf + "Program will TERMINATE!"
            'Unrecognized ERROR-reports error and terminates.
            Call LogAccess("Error|after|line|Str$(Erl)!")
            End
    End Select
End Function
Private Sub SaveSettings(sKey As String, sValue As String)
    SaveSetting gAppName, "Settings", sKey, sValue
End Sub

Private Sub SendChange(sUser As String, Join As Boolean)
    Dim bMsg() As Byte
    Dim lPntr As Long
    If Join Then
        bMsg = StrToByte(sUser & " has joined the conversation!")
    Else
        bMsg = StrToByte(sUser & " has left the conversation!")
    End If
    bMsg = Encrypt(bMsg, RandomKey)
    Call AddRecHeader(8, bMsg)
    For lPntr = 1 To Max_Connect
        If Len(User(lPntr, 0)) > 0 Then
            mServer(lPntr).bOutBuffer = bMsg
            mServer(lPntr).TCPSend
        End If
    Next lPntr
End Sub

Private Sub SendToAll(bMsg() As Byte, sSender As String)
    Dim lPntr As Long
    Dim bUser() As Byte
    Dim bOut() As Byte
    bUser = UniToByte(sSender)
    Call AddRecHeader(16, bUser)
    bOut = bMsg
    Call AddRecHeader(8, bOut)
    For lPntr = 1 To Max_Connect
        If Len(User(lPntr, 0)) > 0 Then
            mServer(lPntr).bOutBuffer = bUser
            mServer(lPntr).TCPSend
            mServer(lPntr).bOutBuffer = bOut
            mServer(lPntr).TCPSend
        End If
    Next lPntr
End Sub

Private Sub SendUserList()
    Dim bMsg() As Byte
    Dim sTmp As String
    Dim lPntr As Long
    If frmHidden.Visible Then lstUser.Clear
    For lPntr = 1 To Max_Connect
        If Len(User(lPntr, 0)) > 0 Then
            If frmHidden.Visible Then lstUser.AddItem (User(lPntr, 0))
            sTmp = sTmp & User(lPntr, 0) & Chr$(0)
        End If
    Next lPntr
    Debug.Print sTmp
    bMsg = UniToByte(sTmp)
    Call AddRecHeader(17, bMsg)
    For lPntr = 1 To Max_Connect
        If Len(User(lPntr, 0)) > 0 Then
            mServer(lPntr).bOutBuffer = bMsg
            mServer(lPntr).TCPSend
        End If
    Next lPntr
End Sub


Private Function LocalInit() As Boolean
' Purpose:
'   Starting point for application.
' =====================================================
    Const sProc As String = "LocalInit"
    Dim sTmp As String
    Dim lNum As Long
    On Error GoTo LocalInitErr
    gAppName = App.ProductName
    If IsService Then
    Else
        sTmp = GetSetting(gAppName, "Settings", "Max", "")
    End If
    If Val(sTmp) = 0 Then
        Max_Connect = 5
    Else
        Max_Connect = Val(sTmp)
    End If
    ReDim mServer(Max_Connect)
    For lNum = 0 To Max_Connect
        Set mServer(lNum).Callback(lNum) = Me
        mServer(lNum).EncrFlg = True
    Next
    WinDir = GetWindowsDir
    If IsService Then
    Else
        sTmp = GetSetting(gAppName, "Settings", "Port", "")
    End If
    If Len(sTmp) = 0 Then
        PortListen = 258
    Else
        PortListen = CLng(sTmp)
    End If
    If IPVersion = 0 Then IPVersion = 4
    ReDim User(Max_Connect, 2)
    mServer(0).Listen (PortListen)
'    Me.Top = 200 'Screen.Height / 2 + 200
'    Me.Left = Screen.Width - Me.Width - 200
    Call HexToByte("45434B3120000000", bHeader)
    RandomKey = GetRndKey(32)
    Call GetUserFile
    LocalInit = True
    Exit Function
LocalInitErr:
    LocalInit = False
End Function

Private Sub Form_Load()
    On Error GoTo fLoadErr
    IsService = False 'True
    If IsService Then
        Call ChkInstall
    Else
        If LocalInit Then
            frmHidden.Visible = True
        Else
            GoTo fLoadErr
        End If
    End If
    Exit Sub
fLoadErr:
    'MsgBox "Problem Loading Program"
    Call LogAccess("Problem|loading|the|Program!")
    End
End Sub


Private Sub Form_Unload(Cancel As Integer)
    SimpleServer_CloseSck (0) 'Close listening socket
End Sub



Private Sub Service1_Continue(Success As Boolean)
    'Handle the continue service event
    On Error GoTo ServiceError
    If LocalInit Then
        Success = True
        Call LogAccess("Service|EChat|Continued!")
    Else
        SimpleServer_CloseSck (0) 'Close listening socket
        Call LogAccess("Service|EChat|Continue|Failed!")
    End If
    Exit Sub
ServiceError:
    Service1.LogEvent svcMessageError, svcEventError, "[" & Err.Number & "] " & Err.Description
End Sub

Private Sub Service1_Control(ByVal mEvent As Long)
    'Take control of the service events
    On Error GoTo ServiceError
    Call LogAccess("Service|EChat|Control|" & CStr([mEvent]))
    Exit Sub
ServiceError:
    Service1.LogEvent svcMessageError, svcEventError, "[" & Err.Number & "] " & Err.Description
End Sub
Private Sub Service1_Pause(Success As Boolean)
    'Pause Event Request
    On Error GoTo ServiceError
    Call LogAccess("Service|EChat|Paused!")
    Success = True
    Exit Sub
ServiceError:
    Service1.LogEvent svcMessageError, svcEventError, "[" & Err.Number & "] " & Err.Description
End Sub


Private Sub Service1_Start(Success As Boolean)
    'Start Event Request
    On Error GoTo ServiceError
    If LocalInit Then
        Success = True
        Call LogAccess("Service|EChat|started!")
        Exit Sub
    End If
    Call LogAccess("Service|EChat|Start|Failed!")
    SimpleServer_CloseSck (0) 'Close listening socket
    Exit Sub
ServiceError:
    Service1.LogEvent svcMessageError, svcEventError, "[" & Err.Number & "] " & Err.Description
End Sub


Private Sub Service1_Stop()
    'Stop and terminate the Service
    On Error GoTo ServiceError
    StopService = True
    Call LogAccess("Service|EChat|Stopped!")
    Unload Me
ServiceError:
    Service1.LogEvent svcMessageError, svcEventError, "[" & Err.Number & "] " & Err.Description
End Sub


Private Sub SimpleServer_CloseSck(ByVal Index As Long)
    Dim sClosed As String
    sClosed = User(Index, 0)
    Call mServer(Index).CloseSocket
    Call LogAccess(sClosed & " logged out.")
    User(Index, 0) = ""
    Call SendChange(sClosed, False)
    Call SendUserList
End Sub

Private Sub SimpleServer_Connect(ByVal Index As Long)

End Sub


Private Sub SimpleServer_ConnectionRequest(ByVal Index As Long, ByVal requestID As Long, ByVal lRemotePort As Long, ByVal sRemoteHostIP As String)
    Dim lTmp As Long
    lTmp = GetNextSocket
    If lTmp > Max_Connect Then 'Request will exceed maximum, close the socket
        Call mServer(lIndex).Accept(requestID, 0, "")
        Exit Sub
    Else 'Accept the connection request
        lIndex = lTmp
        RemoteHostIP = sRemoteHostIP
        RemotePort = lRemotePort
        Call mServer(lIndex).Accept(requestID, RemotePort, RemoteHostIP)
        LastConnect = mServer(lIndex).RemoteHostIP
    End If
End Sub


Private Sub SimpleServer_DataArrival(ByVal Index As Long, ByVal bytesTotal As Long)

End Sub


Private Sub SimpleServer_EncrDataArrival(ByVal Index As Long, ByVal bytesTotal As Long)
    Dim bData() As Byte
    'This routine is re-entrant, hence the next 3 variables must be static
    Static InBuff() As Byte
    Static Header() As Byte
    Static RecLen As Long
    Dim bResponse() As Byte
    Dim bBuffer() As Byte
    Dim bRecord() As Byte
    Dim bPW() As Byte
    Dim sMsg As String
    Dim lPntr As Long
    Dim IPAddr As String
    Dim Port As Long
    Call mServer(Index).RecoverData
    bData = mServer(Index).bInBuffer
    Call AddByte(InBuff, bData) 'Add data to buffer
GetNextRecord:
    If GetbSize(InBuff) < 8 Then Exit Sub 'If no record length yet then exit & wait
    If RecLen = 0 Then 'New record
        ReDim Header(7)
        CopyMemory Header(0), InBuff(0), 8
        Call DeleteByte(InBuff, 8)
        RecLen = Header(6) * 256 + Header(7)
    End If
    Select Case Header(0)
        '1. Client Hello, 2. Server Hello, 4. Client Password (encrypted)
        '8. Data (encrypted), 16. Data (unencrypted)
        Case 1, 2, 4, 8, 16
            'Record type OK
        Case Else 'Ignore record
            Call DeleteByte(InBuff, RecLen)
            GoTo Done
    End Select
    If GetbSize(InBuff) >= RecLen Then 'Complete record available
        ReDim bRecord(RecLen - 1)
        CopyMemory bRecord(0), InBuff(0), RecLen
        Call DeleteByte(InBuff, RecLen)
    Else
        Exit Sub 'Wait for complete record
    End If
    Select Case Header(0)
        Case 1 'Client Hello
            User(Index, 0) = GetUser(bRecord)
            If IsValidUser(User(Index, 0)) Then
                bResponse = GetEncrKey(Index, bRecord)
                Call AdjRecHeader(2, bResponse)
                mServer(Index).bOutBuffer = bResponse
                mServer(Index).TCPSend
                Call LogAccess(CStr(Index) & ". " & User(Index, 0) & " logged in from " & LastConnect & ".")
            Else
                bResponse = UniToByte(User(Index, 0) & " is Invalid UserID")
                Call AddRecHeader(16, bResponse)
                mServer(Index).bOutBuffer = bResponse
                mServer(Index).TCPSend
                Call SimpleServer_CloseSck(Index)
           End If
        Case 2 'Server Hello
        Case 4 'Client Password (encrypted)
            bPW = Encrypt(bRecord, bEncryptKey) 'Decrypt Password Hash
            Call DebugPrintByte("PW Hash", bPW)
            If IsValidPassword(User(Index, 0), bPW) Then
                bResponse = Encrypt(RandomKey, bEncryptKey)
                Call DebugPrintByte("Random Key", RandomKey)
                Call AddRecHeader(4, bResponse)
                mServer(Index).bOutBuffer = bResponse
                mServer(Index).TCPSend
                Call SendUserList
                Call SendChange(User(Index, 0), True)
            Else
                bResponse = UniToByte(User(Index, 0) & " has Invalid Password")
                Call AddRecHeader(16, bResponse)
                mServer(Index).bOutBuffer = bResponse
                mServer(Index).TCPSend
                Call LogAccess(User(Index, 0) & " bad password." & ByteToHex(bPW))
                Call SimpleServer_CloseSck(Index)
            End If
        Case 8 'Data (encrypted)
            bData = Encrypt(bRecord, RandomKey) 'Decrypt text
            Call SendToAll(bRecord, User(Index, 0))
        Case 16 'Data (unencrypted)
        Case Else 'Ignore record
            'Do nothing
    End Select
Done:
    RecLen = 0
    ReDim Header(0)
    If GetbSize(InBuff) > 0 Then GoTo GetNextRecord
End Sub


Private Sub SimpleServer_Error(ByVal Index As Long, ByVal Number As Long, Description As String, ByVal Source As String)
    Call LogAccess(CStr(Index) & ". Error" & CStr(Number) & ": " & Description)
End Sub


Private Sub SimpleServer_SendComplete(ByVal Index As Long)

End Sub


Private Sub SimpleServer_SendProgress(ByVal Index As Long, ByVal bytesSent As Long, ByVal bytesRemaining As Long)

End Sub


Private Sub SimpleServer_WndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)

End Sub


