VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "EChat SETUP"
   ClientHeight    =   1185
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5925
   LinkTopic       =   "Form1"
   ScaleHeight     =   1185
   ScaleWidth      =   5925
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPW 
      Caption         =   "PW Maint."
      Height          =   375
      Left            =   4200
      TabIndex        =   3
      Top             =   480
      Width           =   1335
   End
   Begin VB.CommandButton cmdSetup 
      Caption         =   "Setup"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   735
   End
   Begin VB.CommandButton cmdInstall 
      Caption         =   "Iinstall Service"
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Top             =   480
      Width           =   1335
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start Service"
      Height          =   375
      Left            =   2640
      TabIndex        =   0
      Top             =   480
      Width           =   1335
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public gAppName As String

Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const KEY_READ = &H20019
Private Const REG_SZ                As Long = 1
Private Const REG_DWORD             As Long = 4
Private Const ODBC_ADD_DSN = 1      ' Add user data source
Private Const ODBC_ADD_SYS_DSN = 4  ' System DSN functions only work in adminstrative mode

Private Const VER_PLATFORM_WIN32_NT As Long = 2

Private ServState       As SERVICE_STATE
Private Installed       As Boolean
Private sServer         As String
Private sPortListen     As String
Private sMaxSockets     As String
Private sIPHome         As String
Private sKeyBase        As Long
Private sKeyName        As String
Private DataPath        As String
Private DataBase        As String
Private AllUserPath     As String

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (ByRef lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function SQLConfigDataSource Lib "odbccp32.dll" (ByVal hWndParent As Long, ByVal fRequest As Long, ByVal lpszDriver As String, ByVal lpszAttributes As String) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, ByRef TokenHandle As Long) As Long
Private Declare Function GetTokenInformation Lib "advapi32.dll" (ByVal TokenHandle As Long, ByVal TokenInformationClass As Long, TokenInformation As Any, ByVal TokenInformationLength As Long, ReturnLength As Long) As Long

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion      As Long
    dwMinorVersion      As Long
    dwBuildNumber       As Long
    dwPlatformId        As Long
    szCSDVersion        As String * 128 ' Maintenance string for PSS usage
End Type

Private Function IsAdmin() As Boolean
    Dim hToken As Long
    Dim tkElevation As Long
    Dim lRetLen As Long
    Const TOKEN_QUERY = (&H8)
    Const TOKEN_ELEVATION As Long = 20
    If OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, hToken) = 0 Then _
        Err.Raise Err.LastDllError, , "Could not retrieve current Process Token!"
    If GetTokenInformation(hToken, TOKEN_ELEVATION, tkElevation, 4, lRetLen) = 0 Then
        Err.Raise Err.LastDllError, , "Could not retrieve Token Information!"
    Else
        Select Case tkElevation
            Case 0
                IsAdmin = False
            Case Else
                IsAdmin = True
        End Select
    End If
End Function

Private Sub cmdInstall_Click()
    Dim sTemp As String
    Dim lRet As Long
    CheckService
    If Not cmdInstall.Enabled Then Exit Sub
    If Installed = True And cmdInstall.Caption = "Uninstall Service" Then
        DeleteNTService
    ElseIf Installed = False And cmdInstall.Caption = "Install Service" Then
        lRet = SetNTService
        If lRet <> 0 Then
            MsgBox "Service Installation Failed!" & vbCrLf & "This utility must be run in Administrative Mode!", vbExclamation
            Exit Sub
        End If
        MsgBox "Setup should be run before starting Service!", vbInformation
    End If
    CheckService
End Sub
Private Function CreateKey(sKey As String, sData As String) As String
    Dim sKeyBase As Long
    Dim sKeyName As String
    Dim hKey As Long
    Dim lRetVal As Long
    sKeyBase = HKEY_LOCAL_MACHINE
    sKeyName = "SYSTEM\CurrentControlSet\Services\EChatSvc\Parameters"
    lRetVal = RegCreateKey(sKeyBase, sKeyName, hKey)
    If lRetVal <> 0 Then
        CreateKey = vbNullString
        Exit Function
    End If
    lRetVal = RegSetValueEx(hKey, ByVal sKey, 0&, REG_SZ, ByVal sData, Len(sData))
    If lRetVal = 0 Then CreateKey = sData
End Function
Private Function RegQuery(sKeyBase As Long, sKeyName As String, sValueName As String) As String
    Dim lRetVal As Long
    Dim hKey As Long
    Dim vValue As Variant
    Dim cch As Long
    Dim lrc As Long
    Dim lType As Long
    Dim lValue As Long
    Dim sValue As String
    lRetVal = RegOpenKeyEx(sKeyBase, sKeyName, 0, KEY_READ, hKey)
    If lRetVal <> 0 Then 'Service not installed
        RegQuery = vbNullString
        Exit Function
    End If
    On Error GoTo RegQueryError
    lrc = RegQueryValueExNULL(hKey, sValueName, 0&, lType, 0&, cch)
    If lrc <> 0 Then Error 5
    Select Case lType
        Case REG_SZ
            sValue = String(cch, 0)
            lrc = RegQueryValueExString(hKey, sValueName, 0&, lType, sValue, cch)
            If lrc = 0 Then
                vValue = Left$(sValue, cch - 1)
            Else
                vValue = Empty
            End If
        Case REG_DWORD
            lrc = RegQueryValueExLong(hKey, sValueName, 0&, lType, lValue, cch)
            If lrc = 0 Then vValue = lValue
        Case Else
            lrc = -1
    End Select
RegQueryExit:
    RegQuery = vValue
    RegCloseKey (hKey)
    Exit Function
RegQueryError:
    Resume RegQueryExit
End Function
Private Function GetDSN(sDSN As String, sDriver As String, sDBFile As String, lAction As Long) As Long
    Dim sAttributes As String
    Dim sDBQ As String
    Dim lngRet As Long
    Dim hKey As Long
    Dim regValue As String
    Dim valueType As Long
    ' query the Registry to check whether the DSN is already installed
    ' open the key
    sDBQ = RegQuery(HKEY_LOCAL_MACHINE, "SOFTWARE\ODBC\ODBC.INI\" + sDSN, "DBQ")
    If Left$(sDBQ, 11) = "No Such Key" Then
        If Len(sDBFile) Then 'File path/name supplied
            lngRet = MsgBox(sDBQ & vbCrLf & "CREATE IT?", vbYesNo)
            If lngRet = vbYes Then
                sDBQ = ""
            Else
                'Routine failed
                GetDSN = False
                Exit Function
            End If
        Else 'No file name supplied
            GetDSN = False
            Exit Function
        End If
    End If
    If Len(sDBQ) Then 'DBQ found
        If lAction = ODBC_ADD_SYS_DSN Or lAction = ODBC_ADD_DSN Then
            'Verify file actually exists
            If Len(Dir$(sDBFile)) Then
                'Simply return DBQ
                sDBFile = sDBQ
                GetDSN = True
                Exit Function
            Else 'return error
                GetDSN = False
                Exit Function
            End If
        Else 'Delete it
            sAttributes = "DSN=" & sDSN & vbNullChar & "DBQ=" & sDBFile & vbNullChar
            lngRet = SQLConfigDataSource(0&, lAction, sDriver, sAttributes)
        End If
    Else 'Add it
        ' check that the file actually exists
        If Len(sDBFile) > 0 And Len(Dir$(sDBFile)) Then 'create DSN
             sAttributes = "DSN=" & sDSN & vbNullChar & "DBQ=" & sDBFile & vbNullChar
             lngRet = SQLConfigDataSource(0&, lAction, sDriver, sAttributes)
         Else 'Return with error
             MsgBox "Database file doesn't exist!", vbOKOnly + vbCritical
             GetDSN = False
             Exit Function
         End If
    End If
    If lngRet Then
        GetDSN = True
    Else
        GetDSN = False
    End If
End Function
Private Function TestFile(PathName As String, FileName As String) As Boolean
    Dim lngRet As Long
    On Error GoTo TestFileErr
    If Len(Dir(PathName & FileName)) = 0 Then
        MkDir AllUserPath
        lngRet = MsgBox("Database not Found!" & vbCrLf & "Copy blank one?", vbYesNo)
        If lngRet = vbYes Then
            FileCopy App.Path & "\users.db.org", PathName & FileName
        End If
    End If
    Exit Function
TestFileErr:
    If Err = 75 Then Resume Next
End Function

Private Sub CheckService()
    Dim TimeStart As Long
    If GetServiceConfig() = 0 Then
        Installed = True
        cmdInstall.Caption = "Uninstall Service"
TryAgain:
        ServState = GetServiceStatus()
        Select Case ServState
            Case SERVICE_RUNNING
                cmdInstall.Enabled = False
                cmdStart.Caption = "Stop Service"
                cmdStart.Enabled = True
            Case SERVICE_STOPPED
                cmdInstall.Enabled = True
                cmdStart.Caption = "Start Service"
                cmdStart.Enabled = True
            Case SERVICE_START_PENDING, SERVICE_STOP_PENDING
                'Delay while status changes
                TimeStart = Timer - 1
                Do Until CLng(Timer) > TimeStart
                    DoEvents
                Loop
                GoTo TryAgain
            Case Else
                cmdInstall.Caption = "Install Service"
                cmdStart.Enabled = False
        End Select
    Else
        Installed = False
        cmdInstall.Caption = "Install Service"
        cmdStart.Enabled = False
        cmdInstall.Enabled = True
    End If
End Sub


Private Sub cmdPW_Click()
    frmMaint.Show 1
End Sub

Private Sub cmdSetup_Click()
    Dim Response As Long
    Dim TaskID As Long
    If Installed Then
        Response = MsgBox("Service has been installed. Setup will be made for both" _
            & " service and desktop access!", vbYesNo)
        If Response = vbNo Then Exit Sub
    Else
        Response = MsgBox("Service has not been installed yet. Setup will be made" _
            & " for desktop access only!", vbYesNo)
        If Response = vbNo Then Exit Sub
    End If
    sMaxSockets = InputBox("Enter Maximum # of sockets!", "MAX SOCKETS", sMaxSockets)
    sPortListen = InputBox("Enter Port # to Listen on!", "LISTEN PORT", sPortListen)
    If Installed Then
        sMaxSockets = CreateKey("MaxSockets", sMaxSockets)
        sPortListen = CreateKey("PortListen", sPortListen)
    Else
        SaveSetting gAppName, "Settings", "MaxSockets", sMaxSockets
        SaveSetting gAppName, "Settings", "PortListen", sPortListen
    End If
    AllUserPath = "C:\ProgramData\EChat\"
    'Verify database exists
    TaskID = TestFile(AllUserPath, "users.db")
End Sub

Private Sub cmdStart_Click()
    CheckService
    If Not cmdStart.Enabled Then Exit Sub
    If ServState = SERVICE_RUNNING Then
        StopNTService
    ElseIf ServState = SERVICE_STOPPED Then
        StartNTService
    End If
    CheckService
End Sub



Private Sub Form_Activate()
    If Not IsAdmin Then
        MsgBox "This program must be run in Administrative Mode!", vbExclamation
        Unload Me
    End If
End Sub

Private Sub Form_Load()
    gAppName = App.ProductName
    AppPath = App.Path & "\"
    Call CheckService
    If Installed Then
        sKeyBase = HKEY_LOCAL_MACHINE
        sKeyName = "SYSTEM\CurrentControlSet\Services\EChat\Parameters"
        sMaxSockets = RegQuery(sKeyBase, sKeyName, "MaxSockets")
        sPortListen = RegQuery(sKeyBase, sKeyName, "PortListen")
    Else
        GetSetting gAppName, "Settings", "MaxSockets", sMaxSockets
        GetSetting gAppName, "Settings", "PortListen", sPortListen
    End If
End Sub



